<?php
/**
 * @package Free Demo Content
 * @since 1.0.0
 */

class PixelPhotographyThemeWhizzie {

	protected $version = '1.1.0';

	/** @var string Current theme name, used as namespace in actions. */
	protected $pixel_photography_theme_name = '';
	protected $pixel_photography_theme_title = '';

	/** @var string Free Demo Content page slug and title. */
	protected $pixel_photography_page_slug = '';
	protected $pixel_photography_page_title = '';

	/** @var array Free Demo Content steps set by user. */
	protected $pixel_photography_config_steps = array();

	/**
	 * Relative plugin url for this plugin folder
	 * @since 1.0.0
	 * @var string
	*/
	protected $pixel_photography_plugin_url = '';
	protected $pixel_photography_plugin_path = '';
	public $pixel_photography_parent_slug;
	/**
	 * TGMPA instance storage
	 *
	 * @var object
	*/
	protected $pixel_photography_tgmpa_instance;

	/**
	 * TGMPA Menu slug
	 *
	 * @var string
	*/
	protected $pixel_photography_tgmpa_menu_slug = 'tgmpa-install-plugins';

	/**
	 * TGMPA Menu url
	 *
	 * @var string
	*/
	protected $pixel_photography_tgmpa_url = 'themes.php?page=tgmpa-install-plugins';
	/**
	 * Constructor
	 *
	 * @param $pixel_photography_config	Our config parameters
	*/
	public function __construct( $pixel_photography_config ) {
		$this->set_vars( $pixel_photography_config );
		$this->init();

		include_once( ABSPATH . 'wp-admin/includes/plugin.php' );
	}

	/**
	 * Set some settings
	 * @since 1.0.0
	 * @param $pixel_photography_config	Our config parameters
	*/
	public function set_vars( $pixel_photography_config ) {

		require_once trailingslashit( WHIZZIE_DIR ) . 'tgm/tgm.php';

		if( isset( $pixel_photography_config['pixel_photography_page_slug'] ) ) {
			$this->pixel_photography_page_slug = esc_attr( $pixel_photography_config['pixel_photography_page_slug'] );
		}
		if( isset( $pixel_photography_config['pixel_photography_page_title'] ) ) {
			$this->pixel_photography_page_title = esc_attr( $pixel_photography_config['pixel_photography_page_title'] );
		}
		if( isset( $pixel_photography_config['steps'] ) ) {
			$this->pixel_photography_config_steps = $pixel_photography_config['steps'];
		}

		$this->pixel_photography_plugin_path = trailingslashit( dirname( __FILE__ ) );
		$relative_url = str_replace( get_template_directory(), '', $this->pixel_photography_plugin_path );
		$this->pixel_photography_plugin_url = trailingslashit( get_template_directory_uri() . $relative_url );
		$current_theme = wp_get_theme();
		$this->pixel_photography_theme_title = $current_theme->get( 'Name' );
		$this->pixel_photography_theme_name = strtolower( preg_replace( '#[^a-zA-Z]#', '', $current_theme->get( 'Name' ) ) );
		$this->pixel_photography_page_slug = apply_filters( $this->pixel_photography_theme_name . '_theme_setup_wizard_pixel_photography_page_slug', $this->pixel_photography_theme_name . '-freedemocontent' );
		$this->pixel_photography_parent_slug = apply_filters( $this->pixel_photography_theme_name . '_theme_setup_wizard_parent_slug', '' );
	}

	/**
	 * Hooks and filters
	 * @since 1.0.0
	*/
	public function init() {

		if ( class_exists( 'TGM_Plugin_Activation' ) && isset( $GLOBALS['tgmpa'] ) ) {
			add_action( 'init', array( $this, 'get_tgmpa_instance' ), 30 );
			add_action( 'init', array( $this, 'set_tgmpa_url' ), 40 );
		}

		add_action( 'admin_enqueue_scripts', array( $this, 'enqueue_scripts' ) );
		// add_action( 'admin_menu', array( $this, 'menu_page' ) );
		add_action( 'admin_init', array( $this, 'get_plugins' ), 30 );
		add_filter( 'tgmpa_load', array( $this, 'tgmpa_load' ), 10, 1 );
		add_action( 'wp_ajax_setup_plugins', array( $this, 'setup_plugins' ) );
		add_action( 'wp_ajax_setup_widgets', array( $this, 'setup_widgets' ) );
	}

	public function enqueue_scripts() {
		wp_enqueue_style( 'pixel-photography-free-demo-content-style', get_template_directory_uri() . '/inc/free-demo-content/css-and-js/free-demo-content-style.css');
		wp_register_script( 'pixel-photography-free-demo-content-script', get_template_directory_uri() . '/inc/free-demo-content/css-and-js/free-demo-content-script.js', array( 'jquery' ), time() );
		wp_localize_script(
			'pixel-photography-free-demo-content-script',
			'pixel_photography_whizzie_params',
			array(
				'ajaxurl' 		=> admin_url( 'admin-ajax.php' ),
				'wpnonce' 		=> wp_create_nonce( 'whizzie_nonce' ),
				'verify_text'	=> esc_html( 'verifying', 'pixel-photography' )
			)
		);
		wp_enqueue_script( 'pixel-photography-free-demo-content-script' );
	}

	public function tgmpa_load( $status ) {
		return is_admin() || current_user_can( 'install_themes' );
	}

	/**
	 * Get configured TGMPA instance
	 *
	 * @access public
	 * @since 1.1.2
	*/
	public function get_tgmpa_instance() {
		$this->pixel_photography_tgmpa_instance = call_user_func( array( get_class( $GLOBALS['tgmpa'] ), 'get_instance' ) );
	}

	/**
	 * Update $pixel_photography_tgmpa_menu_slug and $tgmpa_parent_slug from TGMPA instance
	 *
	 * @access public
	 * @since 1.1.2
	*/
	public function set_tgmpa_url() {
		$this->pixel_photography_tgmpa_menu_slug = ( property_exists( $this->pixel_photography_tgmpa_instance, 'menu' ) ) ? $this->pixel_photography_tgmpa_instance->menu : $this->pixel_photography_tgmpa_menu_slug;
		$this->pixel_photography_tgmpa_menu_slug = apply_filters( $this->pixel_photography_theme_name . '_theme_setup_wizard_tgmpa_menu_slug', $this->pixel_photography_tgmpa_menu_slug );
		$tgmpa_parent_slug = ( property_exists( $this->pixel_photography_tgmpa_instance, 'pixel_photography_parent_slug' ) && $this->pixel_photography_tgmpa_instance->pixel_photography_parent_slug !== 'themes.php' ) ? 'admin.php' : 'themes.php';
		$this->pixel_photography_tgmpa_url = apply_filters( $this->pixel_photography_theme_name . '_theme_setup_wizard_tgmpa_url', $tgmpa_parent_slug . '?page=' . $this->pixel_photography_tgmpa_menu_slug );
	}


	/**  Make a modal screen for the wizard **/
	// public function menu_page() {
	// 	add_theme_page( esc_html( $this->pixel_photography_page_title ), esc_html( $this->pixel_photography_page_title ), 'manage_options', $this->pixel_photography_page_slug, array( $this, 'pixel_photography_guide' ) );
	// }

	/*** Make an interface for the wizard ***/
	public function Pixel_Photography_Demo_Content_Page() {

		tgmpa_load_bulk_installer();

		// install plugins with TGM.
		if ( ! class_exists( 'TGM_Plugin_Activation' ) || ! isset( $GLOBALS['tgmpa'] ) ) {
			die( 'Failed to find TGM' );
		}
		$pixel_photography_url = wp_nonce_url( add_query_arg( array( 'plugins' => 'go' ) ), 'whizzie-setup' );

		// copied from TGM
		$pixel_photography_method = ''; // Leave blank so WP_Filesystem can populate it as necessary.
		$pixel_photography_fields = array_keys( $_POST ); // Extra fields to pass to WP_Filesystem.
		if ( false === ( $creds = request_filesystem_credentials( esc_url_raw( $pixel_photography_url ), $pixel_photography_method, false, false, $pixel_photography_fields ) ) ) {
			return true; // Stop the normal page form from displaying, credential request form will be shown.
		}
		// Now we have some credentials, setup WP_Filesystem.
		if ( ! WP_Filesystem( $creds ) ) {
			// Our credentials were no good, ask the user for them again.
			request_filesystem_credentials( esc_url_raw( $pixel_photography_url ), $pixel_photography_method, true, false, $pixel_photography_fields );
			return true;
		}

		/* If we arrive here, we have the filesystem */ ?>
		<div class="wrap">
			<?php echo '<div class="whizzie-wrap">';
				// The wizard is a list with only one item visible at a time
				$pixel_photography_steps = $this->get_steps();
				echo '<div class="abcd">';

					echo '<ul class="whizzie-nav wizard-icon-nav nav-tab-wrapper clearfix">';?>

					<?php
						$pixel_photography_stepI=1;
						foreach( $pixel_photography_steps as $pixel_photography_step ) {
							$pixel_photography_stepAct=($pixel_photography_stepI ==1)? 1 : 0;
							if( isset( $pixel_photography_step['icon_text'] ) && $pixel_photography_step['icon_text'] ) {
								echo '<li class="commom-cls nav-step-' . esc_attr( $pixel_photography_step['id'] ) . '" wizard-steps="step-'.esc_attr( $pixel_photography_step['id'] ).'" data-enable="'.$pixel_photography_stepAct.'">
								<a class="nav-tab upgrade-button">'.esc_attr( $pixel_photography_step['icon_text'] ).'</a>
								</li>';
							}
						$pixel_photography_stepI++;}

					echo '</ul>';
			 	echo '</div>';

				echo '<div class="second-div">';
					echo '<ul class="whizzie-menu wizard-menu-page theme-details">';
					foreach( $pixel_photography_steps as $pixel_photography_step ) {
						$pixel_photography_class = 'step step-' . esc_attr( $pixel_photography_step['id'] );
						echo '<li data-step="' . esc_attr( $pixel_photography_step['id'] ) . '" class="' . esc_attr( $pixel_photography_class ) . '" >';

							$pixel_photography_content = call_user_func( array( $this, $pixel_photography_step['view'] ) );
							if( isset( $pixel_photography_content['summary'] ) ) {
								printf(
									'<div class="summary">%s</div>',
									wp_kses_post( $pixel_photography_content['summary'] )
								);
							}
							if( isset( $pixel_photography_content['detail'] ) ) {
								// Add a link to see more detail
								printf( '<div class="wz-require-plugins">');
								printf(
									'<div class="detail">%s</div>',
									$pixel_photography_content['detail'] // Need to escape this
								);
								printf('</div>');
							}
							printf('<div class="wizard-button-wrapper">');
								// The next button
								if( isset( $pixel_photography_step['button_text'] ) && $pixel_photography_step['button_text'] ) {
									printf(
										'<div class="button-wrap"><a href="#" class="button button-primary do-it" data-callback="%s" data-step="%s">%s</a></div>',
										esc_attr( $pixel_photography_step['callback'] ),
										esc_attr( $pixel_photography_step['id'] ),
										esc_html( $pixel_photography_step['button_text'] )
									);
								}

								if( isset( $pixel_photography_step['button_text_one'] )) {
									printf(
										'<div class="button-wrap button-wrap-one">
											<a href="#" class="button button-primary do-it" data-callback="install_widgets" data-step="widgets"><p class="demo-type-text">%s</p></a>
										</div>',
										esc_html( $pixel_photography_step['button_text_one'] )
									);
								}
							printf('</div>');
						echo '</li>';
					}
					echo '</ul>';

				echo '</div>';
				?>
			<?php echo '</div>';?>
		</div>
	<?php }

	/**
	 * Set options for the steps
	 * @return Array
	*/
	public function get_steps() {
		$pixel_photography_dev_steps = $this->pixel_photography_config_steps;
		$pixel_photography_steps = array(
			'plugins' => array(
				'id'			=> 'plugins',
				'title'			=> __( 'Plugins', 'pixel-photography' ),
				'icon'			=> 'admin-plugins',
				'view'			=> 'get_step_plugins',
				'callback'		=> 'install_plugins',
				'button_text'	=> __( 'Install Plugins', 'pixel-photography' ),
				'can_skip'		=> true,
				'icon_text'      => 'Plugins'
			),
			'widgets' => array(
				'id'			=> 'widgets',
				'title'			=> __( 'Customizer', 'pixel-photography' ),
				'icon'			=> 'welcome-widgets-menus',
				'view'			=> 'get_step_widgets',
				'callback'		=> 'install_widgets',
				'button_text_one'	=> __( 'Import Demo Content', 'pixel-photography' ),

				'can_skip'		=> true,
				'icon_text'      => 'Import Demo Content'
			),
			'done' => array(
				'id'			=> 'done',
				'title'			=> __( 'All Done', 'pixel-photography' ),
				'icon'			=> 'yes',
				'view'			=> 'get_step_done',
				'callback'		=> '',
				'icon_text'      => 'Done'
			)
		);

		// Iterate through each step and replace with dev config values
		if( $pixel_photography_dev_steps ) {
			// Configurable elements - these are the only ones the dev can update from config.php
			$can_config = array( 'title', 'icon', 'button_text', 'can_skip' );
			foreach( $pixel_photography_dev_steps as $dev_step ) {
				// We can only proceed if an ID exists and matches one of our IDs
				if( isset( $dev_step['id'] ) ) {
					$id = $dev_step['id'];
					if( isset( $pixel_photography_steps[$id] ) ) {
						foreach( $can_config as $element ) {
							if( isset( $dev_step[$element] ) ) {
								$pixel_photography_steps[$id][$element] = $dev_step[$element];
							}
						}
					}
				}
			}
		}
		return $pixel_photography_steps;
	}

	/*** Print the content for the intro step ***/
		public function get_step_importer() { ?>
		<div class="summary">
			<p>
				<?php esc_html_e('Thank you for choosing this Pixel Photography Theme. Using this quick setup wizard, you will be able to configure your new website and get it running in just a few minutes. Just follow these simple steps mentioned in the wizard and get started with your website.','pixel-photography'); ?>
			</p>
		</div>
	<?php }

	/**
	 * Get the content for the plugins step
	 * @return $pixel_photography_content Array
	*/
	public function get_step_plugins() {
		$plugins = $this->get_plugins();
		$pixel_photography_content = array(); ?>
			<div class="summary">
				<p>
					<?php esc_html_e('Install Recommended Plugins:	','pixel-photography') ?>
				</p>
			</div>
		<?php // The detail element is initially hidden from the user
		$pixel_photography_content['detail'] = '<span class="wizard-plugin-count">'.count($plugins['all']).'</span><ul class="whizzie-do-plugins">';
		// Add each plugin into a list
		foreach( $plugins['all'] as $slug=>$plugin ) {
			$pixel_photography_content['detail'] .= '<li data-slug="' . esc_attr( $slug ) . '">' . esc_html( $plugin['name'] ) . '<div class="wizard-plugin-title">';

			$pixel_photography_content['detail'] .= '<span class="wizard-plugin-status">Installation Required</span><i class="spinner"></i></div></li>';
		}
		$pixel_photography_content['detail'] .= '</ul>';

		return $pixel_photography_content;
	}

	/**    Print the content for the intro step     **/
	public function get_step_widgets() { ?>
		<div class="summary">
			<p>
				<?php esc_html_e('This theme allows you to Import Demo Content content and add widgets. Install them using the button below. You can also update or deactivate them using the Customizer.','pixel-photography'); ?>
			</p>
		</div>
	<?php }

	/***  Print the content for the final step  ***/
	public function get_step_done() { ?>

		<div class="setup-finish">
			<p>
				<?php echo esc_html('Your demo content has been imported successfully. Click the finish button for more information.'); ?>
			</p>
			<div class="finish-buttons">
				<a href="<?php echo esc_url( admin_url( 'themes.php?page=pixel-photography-themeinfo-page' ) ); ?>" class="wz-btn-customizer" target="_blank"><?php esc_html_e('Pixel Photography Info','pixel-photography') ?></a>
				<a href="<?php echo esc_url(admin_url('/customize.php')); ?>" class="wz-btn-customizer" target="_blank"><?php esc_html_e('Customizer Settings','pixel-photography') ?></a>
				<a href="" class="wz-btn-builder" target="_blank"><?php esc_html_e('Customize Your Demo','pixel-photography'); ?></a>
				<a href="<?php echo esc_url(home_url()); ?>" class="wz-btn-visit-site" target="_blank"><?php esc_html_e('Visit Your Site','pixel-photography'); ?></a>
			</div>
			<div class="finish-buttons">
				<a href="<?php echo esc_url(admin_url()); ?>" class="button button-primary"><?php esc_html_e('Finish','pixel-photography'); ?></a>
			</div>
		</div>

	<?php }

	/***  Get the plugins registered with TGMPA  ***/
	public function get_plugins() {
		$instance = call_user_func( array( get_class( $GLOBALS['tgmpa'] ), 'get_instance' ) );
		$plugins = array(
			'all' 		=> array(),
			'install'	=> array(),
			'update'	=> array(),
			'activate'	=> array()
		);
		foreach( $instance->plugins as $slug=>$plugin ) {
			if( $instance->is_plugin_active( $slug ) && false === $instance->does_plugin_have_update( $slug ) ) {
				// Plugin is installed and up to date
				continue;
			} else {
				$plugins['all'][$slug] = $plugin;
				if( ! $instance->is_plugin_installed( $slug ) ) {
					$plugins['install'][$slug] = $plugin;
				} else {
					if( false !== $instance->does_plugin_have_update( $slug ) ) {
						$plugins['update'][$slug] = $plugin;
					}
					if( $instance->can_plugin_activate( $slug ) ) {
						$plugins['activate'][$slug] = $plugin;
					}
				}
			}
		}
		return $plugins;
	}

	public function setup_plugins() {
		if ( ! check_ajax_referer( 'whizzie_nonce', 'wpnonce' ) || empty( $_POST['slug'] ) ) {
			wp_send_json_error( array( 'error' => 1, 'message' => esc_html__( 'No Slug Found','pixel-photography' ) ) );
		}
		$json = array();
		// send back some json we use to hit up TGM
		$plugins = $this->get_plugins();

		// what are we doing with this plugin?
		foreach ( $plugins['activate'] as $slug => $plugin ) {
			if ( $_POST['slug'] == $slug ) {
				$json = array(
					'url'           => admin_url( $this->pixel_photography_tgmpa_url ),
					'plugin'        => array( $slug ),
					'tgmpa-page'    => $this->pixel_photography_tgmpa_menu_slug,
					'plugin_status' => 'all',
					'_wpnonce'      => wp_create_nonce( 'bulk-plugins' ),
					'action'        => 'tgmpa-bulk-activate',
					'action2'       => - 1,
					'message'       => esc_html__( 'Activating Plugin','pixel-photography' ),
				);
				break;
			}
		}
		foreach ( $plugins['update'] as $slug => $plugin ) {
			if ( $_POST['slug'] == $slug ) {
				$json = array(
					'url'           => admin_url( $this->pixel_photography_tgmpa_url ),
					'plugin'        => array( $slug ),
					'tgmpa-page'    => $this->pixel_photography_tgmpa_menu_slug,
					'plugin_status' => 'all',
					'_wpnonce'      => wp_create_nonce( 'bulk-plugins' ),
					'action'        => 'tgmpa-bulk-update',
					'action2'       => - 1,
					'message'       => esc_html__( 'Updating Plugin','pixel-photography' ),
				);
				break;
			}
		}
		foreach ( $plugins['install'] as $slug => $plugin ) {
			if ( $_POST['slug'] == $slug ) {
				$json = array(
					'url'           => admin_url( $this->pixel_photography_tgmpa_url ),
					'plugin'        => array( $slug ),
					'tgmpa-page'    => $this->pixel_photography_tgmpa_menu_slug,
					'plugin_status' => 'all',
					'_wpnonce'      => wp_create_nonce( 'bulk-plugins' ),
					'action'        => 'tgmpa-bulk-install',
					'action2'       => - 1,
					'message'       => esc_html__( 'Installing Plugin','pixel-photography' ),
				);
				break;
			}
		}
		if ( $json ) {
			$json['hash'] = md5( serialize( $json ) ); // used for checking if duplicates happen, move to next plugin
			wp_send_json( $json );
		} else {
			wp_send_json( array( 'done' => 1, 'message' => esc_html__( 'Success','pixel-photography' ) ) );
		}
		exit;
	}


	//. - . - . - . - . - . - . - . - . - . - . - . - . MENUS . - . - . - . - . - . - . - . - . - . - . - . - .//
	
	public function Pixel_Photography_Customizer_Header_Menu() {
		// ------- Create Primary Menu --------
		$pixel_photography_themename = 'Pixel Photography'; // Ensure the theme name is set
		$pixel_photography_menuname = $pixel_photography_themename . ' Primary Menu';
		$pixel_photography_menulocation = 'menu-1';
		$pixel_photography_menu_exists = wp_get_nav_menu_object($pixel_photography_menuname);

		if (!$pixel_photography_menu_exists) {
			$pixel_photography_menu_id = wp_create_nav_menu($pixel_photography_menuname);

			// Home
			wp_update_nav_menu_item($pixel_photography_menu_id, 0, array(
				'menu-item-title' => __('Home', 'pixel-photography'),
				'menu-item-classes' => 'home',
				'menu-item-url' => home_url('/'),
				'menu-item-status' => 'publish'
			));

			// About
			$pixel_photography_page_about = get_page_by_path('about');
			if($pixel_photography_page_about){
				wp_update_nav_menu_item($pixel_photography_menu_id, 0, array(
					'menu-item-title' => __('About', 'pixel-photography'),
					'menu-item-classes' => 'about',
					'menu-item-url' => get_permalink($pixel_photography_page_about),
					'menu-item-status' => 'publish'
				));
			}

			// Page
			$pixel_photography_page_Page = get_page_by_path('Page');
			if($pixel_photography_page_Page){
				wp_update_nav_menu_item($pixel_photography_menu_id, 0, array(
					'menu-item-title' => __('Page', 'pixel-photography'),
					'menu-item-classes' => 'Page',
					'menu-item-url' => get_permalink($pixel_photography_page_Page),
					'menu-item-status' => 'publish'
				));
			}

			// Blog
			$pixel_photography_page_blog = get_page_by_path('blog');
			if($pixel_photography_page_blog){
				wp_update_nav_menu_item($pixel_photography_menu_id, 0, array(
					'menu-item-title' => __('Blog', 'pixel-photography'),
					'menu-item-classes' => 'blog',
					'menu-item-url' => get_permalink($pixel_photography_page_blog),
					'menu-item-status' => 'publish'
				));
			}

			// Contact Us
			$pixel_photography_page_contact = get_page_by_path('contact');
			if($pixel_photography_page_contact){
				wp_update_nav_menu_item($pixel_photography_menu_id, 0, array(
					'menu-item-title' => __('Contact Us', 'pixel-photography'),
					'menu-item-classes' => 'contact',
					'menu-item-url' => get_permalink($pixel_photography_page_contact),
					'menu-item-status' => 'publish'
				));
			}

			// Assign menu to location if not set
			if (!has_nav_menu($pixel_photography_menulocation)) {
				$pixel_photography_locations = get_theme_mod('nav_menu_locations');
				$pixel_photography_locations[$pixel_photography_menulocation] = $pixel_photography_menu_id; // Use $pixel_photography_menu_id here
				set_theme_mod('nav_menu_locations', $pixel_photography_locations);
			}
		}
	}


	/**
	* Imports the Demo Content
	* @since 1.1.0
	*/
	public function setup_widgets() {

		//. - . - . - . - . - . - . - . - . - . - . - . - . MENU PAGES . - . - . - . - . - . - . - . - . - . - . - . - .//
		
			$pixel_photography_home_id='';
			$pixel_photography_home_content = '';

			$pixel_photography_home_title = 'Home';
			$pixel_photography_home = array(
					'post_type' => 'page',
					'post_title' => $pixel_photography_home_title,
					'post_content'  => $pixel_photography_home_content,
					'post_status' => 'publish',
					'post_author' => 1,
					'post_slug' => 'home'
			);
			$pixel_photography_home_id = wp_insert_post($pixel_photography_home);

			//Set the home page template
			add_post_meta( $pixel_photography_home_id, '_wp_page_template', 'default-home.php' );

			//Set the static front page
			$pixel_photography_home = get_page_by_title( 'Home' );
			update_option( 'page_on_front', $pixel_photography_home->ID );
			update_option( 'show_on_front', 'page' );


			// Create a posts page and assign the template
			$pixel_photography_blog_title = 'Blog';
			$pixel_photography_blog_check = get_page_by_path('blog');
			if (!$pixel_photography_blog_check) {
				$pixel_photography_blog = array(
					'post_type'    => 'page',
					'post_title'   => $pixel_photography_blog_title,
					'post_status'  => 'publish',
					'post_author'  => 1,
					'post_name'    => 'blog'
				);
				$pixel_photography_blog_id = wp_insert_post($pixel_photography_blog);

				// Set the posts page
				if (!is_wp_error($pixel_photography_blog_id)) {
					update_option('page_for_posts', $pixel_photography_blog_id);
				}
			}

			// Create a Contact Us page and assign the template
			$pixel_photography_contact_title = 'Contact Us';
			$pixel_photography_contact_check = get_page_by_path('contact');
			if (!$pixel_photography_contact_check) {
				$pixel_photography_contact = array(
					'post_type'    => 'page',
					'post_title'   => $pixel_photography_contact_title,
					'post_status'  => 'publish',
					'post_content'   => 'Lorem Ipsum is simply dummy text of the printing and typesetting industry. Lorem Ipsum has been the industry\'s standard dummy text ever since the 1500s, when an unknown printer took a galley of type and scrambled it to make a type specimen book. It has survived not only five centuries, but also the leap into electronic typesetting, remaining essentially unchanged. It was popularised in the 1960s with the release of Letraset sheets containing Lorem Ipsum passages, and more recently with desktop publishing software like Aldus PageMaker including versions of Lorem Ipsum.',
					'post_author'  => 1,
					'post_name'    => 'contact'
				);
				wp_insert_post($pixel_photography_contact);
			}

			// Create a About page and assign the template
			$pixel_photography_about_title = 'About';
			$pixel_photography_about_check = get_page_by_path('about');
			if (!$pixel_photography_about_check) {
				$pixel_photography_about = array(
					'post_type'    => 'page',
					'post_title'   => $pixel_photography_about_title,
					'post_status'  => 'publish',
					'post_content'   => 'Lorem Ipsum is simply dummy text of the printing and typesetting industry. Lorem Ipsum has been the industry\'s standard dummy text ever since the 1500s, when an unknown printer took a galley of type and scrambled it to make a type specimen book. It has survived not only five centuries, but also the leap into electronic typesetting, remaining essentially unchanged. It was popularised in the 1960s with the release of Letraset sheets containing Lorem Ipsum passages, and more recently with desktop publishing software like Aldus PageMaker including versions of Lorem Ipsum.',
					'post_author'  => 1,
					'post_name'    => 'about'
				);
				wp_insert_post($pixel_photography_about);
			}

			// Create a Page page and assign the template
			$pixel_photography_Page_title = 'Page';
			$pixel_photography_Page_check = get_page_by_path('Page');
			if (!$pixel_photography_Page_check) {
				$pixel_photography_Page = array(
					'post_type'    => 'page',
					'post_title'   => $pixel_photography_Page_title,
					'post_status'  => 'publish',
					'post_content'   => 'Lorem Ipsum is simply dummy text of the printing and typesetting industry. Lorem Ipsum has been the industry\'s standard dummy text ever since the 1500s, when an unknown printer took a galley of type and scrambled it to make a type specimen book. It has survived not only five centuries, but also the leap into electronic typesetting, remaining essentially unchanged. It was popularised in the 1960s with the release of Letraset sheets containing Lorem Ipsum passages, and more recently with desktop publishing software like Aldus PageMaker including versions of Lorem Ipsum.',
					'post_author'  => 1,
					'post_name'    => 'Page'
				);
				wp_insert_post($pixel_photography_Page);
			}

			
		//. - . - . - . - . - . - . - . - . - . - . - . - . FRONTPAGE CONTENT . - . - . - . - . - . - . - . - . - . - . - . - .//

			set_theme_mod('pixel_photography_banner_section_on_off_setting',true);
			set_theme_mod('pixel_photography_category_section_on_off_setting',true);

			set_theme_mod('pixel_photography_slider',3);
	
			$pixel_photography_diff_headings = array(
				'Capturing Moments. Creating Memories.',
				'Professional Photography for Every Occasion',
				'Tell Your Story Through Beautiful Photos'
			);

			for($pixel_photography_i=1;$pixel_photography_i<=3;$pixel_photography_i++){
				set_theme_mod( 'pixel_photography_banner_short_heading'.$pixel_photography_i, 'HEADING HERE' );
				set_theme_mod('pixel_photography_banner_heading'.$pixel_photography_i, $pixel_photography_diff_headings[$pixel_photography_i - 1]);
				set_theme_mod( 'pixel_photography_banner_button_link'.$pixel_photography_i, '#' );
				set_theme_mod( 'pixel_photography_banner_image'.$pixel_photography_i,get_template_directory_uri().'/assets/images/slider.png' );
			}

			set_theme_mod('pixel_photography_services',6);
	
			$pixel_photography_services_date = array(
				'30 May 2024',
				'01 May 2024',
				'26 APril 2024',
				'17 May 2024',
				'05 June 2024',
				'21 May 2024'
			);

			$pixel_photography_services_box_heading = array(
				'Professional Portrait Sessions',
				'Event and Wedding Photography',
				'Corporate and Business Photography',
				'Product Photography for E-commerce',
				'Nature and Landscape Photography',
				'Fashion and Editorial Photography'
			);

			for($pixel_photography_i=1;$pixel_photography_i<=6;$pixel_photography_i++){
				set_theme_mod('pixel_photography_services_date'.$pixel_photography_i, $pixel_photography_services_date[$pixel_photography_i - 1]);
				set_theme_mod('pixel_photography_services_box_heading'.$pixel_photography_i, $pixel_photography_services_box_heading[$pixel_photography_i - 1]);
				set_theme_mod('pixel_photography_services_image' . $pixel_photography_i, get_template_directory_uri() . '/assets/images/services' . $pixel_photography_i . '.png');
			}
			

			set_theme_mod('pixel_photography_category_short_heading','HEADING HERE');
			set_theme_mod('pixel_photography_category_heading','Top Categories');

			set_theme_mod('pixel_photography_category',6);
	
			$pixel_photography_category_box_heading = array(
				'Portrait Photography',
				'Landscape Photography',
				'Wedding Photography',
				'Event Photography',
				'Fashion Photography',
				'Nature Photography'
			);

			for($pixel_photography_i=1;$pixel_photography_i<=6;$pixel_photography_i++){
				set_theme_mod('pixel_photography_category_box_heading'.$pixel_photography_i, $pixel_photography_category_box_heading[$pixel_photography_i - 1]);
				set_theme_mod('pixel_photography_category_image' . $pixel_photography_i, get_template_directory_uri() . '/assets/images/category' . $pixel_photography_i . '.png');
			}

		$this->Pixel_Photography_Customizer_Header_Menu();
	}

	//guidline for about theme
	public function pixel_photography_guide() {
		$display_string = '';
		//custom function about theme customizer
		$return = add_query_arg( array()) ;
		$theme = wp_get_theme( 'pixel-photography' );
		?>
		<div class="wrapper-info wrap about-wrap access-wrap">
			<div class="tab-sec theme-option-tab">
				<div id="demo_offer" class="tabcontent open">
					<?php $this->Pixel_Photography_Demo_Content_Page(); ?>
				</div>
			</div>
		</div>
		
	<?php }
}